//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MainDemoQualDlg.h"
#include "MainDemo_.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm2 *Form2;
//---------------------------------------------------------------------------
__fastcall TForm2::TForm2(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


//------------------------------------------------------------------------------
void __fastcall TForm2::InitTrackBar (TTrackBar *TrackBar, TVideoQuality Setting, BOOL ResetToDefault, BOOL Reversed)
//------------------------------------------------------------------------------
{
   if (Reversed ) {
      TrackBar->Tag = - int (Setting) - 1;
   }
   else {
      TrackBar->Tag = int (Setting) + 1;
   }
   if (! Form1->VideoGrabber1->IsVideoQualitySettingAvailable (Setting) ) {
      TrackBar->Enabled = False;
      TrackBar->Frequency = 0;
      TrackBar->Min = 0;
      TrackBar->Max = 1;
      if (! Reversed ) {
         TrackBar->Position = 0;
      }
      else {
         TrackBar->Position = 1;
      }
   }
   else {
      if (! ResetToDefault ) {
         CanUpdate = false;
      }
      TrackBar->Enabled = True;
      TrackBar->Min = Form1->VideoGrabber1->VideoQualityMin (Setting);
      TrackBar->Max = Form1->VideoGrabber1->VideoQualityMax (Setting);
      TrackBar->Frequency = Form1->VideoGrabber1->VideoQualityStep (Setting);
      if (ResetToDefault ) {
         if (! Reversed ) {
            TrackBar->Position = Form1->VideoGrabber1->VideoQualityDefault (Setting);
         }
         else {
            TrackBar->Position = TrackBar->Max - Form1->VideoGrabber1->VideoQualityDefault (Setting) + TrackBar->Min;
         }
      }
      else {
         if (! Reversed ) {
            TrackBar->Position = Form1->VideoGrabber1->GetVideoQuality (Setting);
         }
         else {
            TrackBar->Position = TrackBar->Max - Form1->VideoGrabber1->GetVideoQuality (Setting) + TrackBar->Min;
         }
      }
   }
   CanUpdate = True;
}


//------------------------------------------------------------------------------
void __fastcall TForm2::InitTrackBars (BOOL ResetToDefault)
//------------------------------------------------------------------------------
{
   InitTrackBar (TrackBar1, vq_Brightness, ResetToDefault, True);
   InitTrackBar (TrackBar2, vq_Contrast, ResetToDefault, True);
   InitTrackBar (TrackBar3, vq_Hue, ResetToDefault, True);
   InitTrackBar (TrackBar4, vq_Saturation, ResetToDefault, True);
   InitTrackBar (TrackBar5, vq_Sharpness, ResetToDefault, True);
   InitTrackBar (TrackBar6, vq_Gamma, ResetToDefault, True);
   InitTrackBar (TrackBar7, vq_WhiteBalance, ResetToDefault, True);
   InitTrackBar (TrackBar8, vq_Gain, ResetToDefault, True);
}


//------------------------------------------------------------------------------
void __fastcall TForm2::OnTrackBarClick (TObject *Sender)
//------------------------------------------------------------------------------
{
   int Selector;
   BOOL Reversed;
   TTrackBar *TrackBar;

   if (CanUpdate) {
      TrackBar = (TTrackBar*) Sender;
      Selector = TrackBar->Tag;
      if (Selector < 0 ) {
         Selector = - Selector;
         Reversed = True;
      }
      else {
         Reversed = False;
      }
      Selector --;
      if (! Reversed ) {
         Form1->VideoGrabber1->SetVideoQuality (TVideoQuality (Selector), TrackBar->Position);
      }
      else {
         Form1->VideoGrabber1->SetVideoQuality (TVideoQuality (Selector), TrackBar->Max - TrackBar->Position + TrackBar->Min);
      }
   }
}


//---------------------------------------------------------------------------
void __fastcall TForm2::FormShow(TObject *Sender)
//---------------------------------------------------------------------------
{
   InitTrackBars (False);
}


//---------------------------------------------------------------------------
void __fastcall TForm2::Button1Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   InitTrackBars (True);
}


//---------------------------------------------------------------------------
void __fastcall TForm2::Button2Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   Close();
}
//---------------------------------------------------------------------------

