//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "MainDemoQualDlg.h"

#include "MainDemo_.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VidGrab"
#pragma resource "*.dfm"
TForm1 *Form1;
TForm *SnapForm;
TImage *SnapImage;
TForm *TransparentForm;
int ThirdPartyFilterIndex;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
//---------------------------------------------------------------------------
{
}

//---------------------------------------------------------------------------
void __fastcall AssignListToComboBox (TComboBox* ComboBox, AnsiString List, int Index)
//---------------------------------------------------------------------------
{
   ComboBox->Items->Text = List;
   if (ComboBox->Items->Count > 0) {
      ComboBox->ItemIndex = Index;
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
//---------------------------------------------------------------------------
{
   // - the global TVideoGrabber parameters can be read from the FormCreate event
   // - the parameters that depend of the current video device are set in the OnChangeVideoDevice event below
   // - the parameters that depend of the current audio device are set in the OnChangeAudioDevice event below

   AssignListToComboBox (ComboBox2, VideoGrabber1->VideoDevices, 0);
   AssignListToComboBox (ComboBox3, VideoGrabber1->AudioDevices, 0);
   AssignListToComboBox (ComboBox5, VideoGrabber1->AudioCompressors, VideoGrabber1->AudioCompressor);
   AssignListToComboBox (ComboBox6, VideoGrabber1->VideoCompressors, VideoGrabber1->VideoCompressor);

   CheckBox2->Checked = VideoGrabber1->Visible;
   CheckBox3->Checked = VideoGrabber1->CaptureAudio  || VideoGrabber1->RenderAudio;
   CheckBox4->Checked = VideoGrabber1->FullScreenPreview;
   CheckBox5->Checked = VideoGrabber1->RenderAudio;
   CheckBox6->Checked = VideoGrabber1->TextOnFrameEnabled;
   CheckBox7->Checked = VideoGrabber1->PreallocCapFileEnabled;
   CheckBox8->Checked = VideoGrabber1->OpenDMLFormat;
   CheckBox10->Checked = VideoGrabber1->TextOnFrameTransparent;
   CheckBox15->Checked = VideoGrabber1->DVNativeInterleavedToAVI;
   CheckBox17->Checked = VideoGrabber1->FrameGrabberEnabled;

   Edit2->Text = VideoGrabber1->StoragePath;
   Edit3->Text = IntToStr (VideoGrabber1->PreallocCapFileSizeInMB);
   Edit6->Text = IntToStr (VideoGrabber1->BurstCount);
   Edit8->Text = FloatToStr (VideoGrabber1->PlayerFrameRate);
   Edit9->Text = IntToStr (VideoGrabber1->BurstInterval);
   Edit11->Text = IntToStr (VideoGrabber1->PreviewZoomSize) + "%";

   RadioGroup1->ItemIndex = int (VideoGrabber1->CompressionType);
   RadioGroup3->ItemIndex = int (VideoGrabber1->CompressionMode);
   RadioGroup7->ItemIndex = int (VideoGrabber1->AutoFileName);

   UpDown1->Position = VideoGrabber1->PlayerFrameRate * 1000;
   UpDown2->Position = (short) VideoGrabber1->PlayerFastSeekMultiplier;

   RefreshPreviewOnParamChange1->Checked = VideoGrabber1->RefreshPreviewOnParamChange;
   AutoPlayClip1->Checked = VideoGrabber1->PlayerAutoStart;

   VideoGrabber1->TextOnFrameString = Memo2->Text;
   VideoGrabber1->TextOnFrameEnabled = CheckBox6->Checked;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1ChangeVideoDevice(TObject *Sender)
//---------------------------------------------------------------------------
{
   // from this event set the parameters that change when the current video capture device change

   EnableDeviceDependentOptions();
   ComboBox2->ItemIndex = VideoGrabber1->VideoDevice; // to be sure the index correspond to the current video device

   ComboBox9->Enabled = VideoGrabber1->IsVideoCrossbarAvailable;

   Edit1->Text = FloatToStr (VideoGrabber1->FrameRate);

   AssignListToComboBox (ComboBox1, VideoGrabber1->VideoSizes, 0);
   AssignListToComboBox (ComboBox7, VideoGrabber1->VideoSubtypes, 0);
   AssignListToComboBox (ComboBox8, VideoGrabber1->AnalogVideoStandards, VideoGrabber1->AnalogVideoStandard);
   AssignListToComboBox (ComboBox9, VideoGrabber1->VideoCrossbarInputs, VideoGrabber1->VideoCrossbarInput);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1ChangeAudioDevice(TObject *Sender)
//---------------------------------------------------------------------------
{
   // from this event set the parameters that change when the current audio capture device change

   AssignListToComboBox (ComboBox4, VideoGrabber1->AudioFormats, VideoGrabber1->AudioFormat);
   AssignListToComboBox (ComboBox10, VideoGrabber1->AudioInputs, VideoGrabber1->AudioInput);
   TrackBar3->Position = VideoGrabber1->AudioVolume;
   TrackBar4->Position = VideoGrabber1->AudioInputLevel;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::EnableDeviceDependentOptions (void)
//---------------------------------------------------------------------------
{
   // refresh the controls according to the TVideoGrabber's states

   CheckBox9->Checked = VideoGrabber1->OverlayEnabled;
   CheckBox9->Enabled = VideoGrabber1->IsOverlayAvailable;
   CheckBox12->Checked = VideoGrabber1->DVReduceFrameRate;
   CheckBox12->Enabled = VideoGrabber1->IsDigitalVideoIn;
   CheckBox14->Checked = ! VideoGrabber1->DVUseExternalAudio;
   CheckBox14->Enabled = VideoGrabber1->IsDigitalVideoIn;
   CheckBox15->Enabled = VideoGrabber1->IsDigitalVideoIn;

   Label10->Enabled = VideoGrabber1->IsDigitalVideoIn;

   Edit1->Enabled =  ! VideoGrabber1->IsDigitalVideoIn;
   Button12->Enabled = ! VideoGrabber1->IsDigitalVideoIn;

   SendVCRcommands1->Enabled = VideoGrabber1->IsVCRCommandAvailable;

   Button3->Enabled = ! VideoGrabber1->IsDigitalVideoIn;
   Button13->Enabled = VideoGrabber1->IsVideoQualityAvailable;
   Button15->Enabled = VideoGrabber1->IsTVTunerAvailable;

   ComboBox3->Enabled = (VideoGrabber1->CaptureAudio || VideoGrabber1->RenderAudio) && ! (VideoGrabber1->IsDigitalVideoIn && (! VideoGrabber1->DVUseExternalAudio));
   ComboBox4->Enabled = VideoGrabber1->CaptureAudio || VideoGrabber1->RenderAudio;

   ComboBox8->Enabled = VideoGrabber1->IsAnalogVideoDecoderAvailable;

   RadioGroup3->Enabled = true;
   RadioGroup1->Enabled = true;

   if (! VideoGrabber1->CaptureAudio)  {
      RadioGroup1->ItemIndex = 0;
      RadioGroup1->Enabled = false;
   };

   // frame capture - one shot
   Button23->Enabled = VideoGrabber1->FrameGrabberEnabled;
   Button21->Enabled = VideoGrabber1->FrameGrabberEnabled;
   Button24->Enabled = VideoGrabber1->FrameGrabberEnabled;
   CheckBox1->Enabled = VideoGrabber1->FrameGrabberEnabled;
   Edit12->Enabled = VideoGrabber1->FrameGrabberEnabled;

   // frame capture - burst mode
   Button5->Enabled = VideoGrabber1->FrameGrabberEnabled;
   Button6->Enabled = VideoGrabber1->FrameGrabberEnabled;
   Button7->Enabled = VideoGrabber1->FrameGrabberEnabled;
   Button19->Enabled = VideoGrabber1->FrameGrabberEnabled;
   Edit6->Enabled = VideoGrabber1->FrameGrabberEnabled;
   Edit9->Enabled = VideoGrabber1->FrameGrabberEnabled;

   // write text over frames
   CheckBox6->Enabled = VideoGrabber1->FrameGrabberEnabled;
   CheckBox10->Enabled = VideoGrabber1->FrameGrabberEnabled;
   RadioGroup2->Enabled = VideoGrabber1->FrameGrabberEnabled;
   Memo2->Enabled = VideoGrabber1->FrameGrabberEnabled;
   Edit7->Enabled = VideoGrabber1->FrameGrabberEnabled;
   Edit14->Enabled = VideoGrabber1->FrameGrabberEnabled;
   Edit15->Enabled = VideoGrabber1->FrameGrabberEnabled;

   // draw shape over frames
   CheckBox11->Enabled = VideoGrabber1->FrameGrabberEnabled;
   Edit16->Enabled = VideoGrabber1->FrameGrabberEnabled;
   Edit17->Enabled = VideoGrabber1->FrameGrabberEnabled;
   Edit18->Enabled = VideoGrabber1->FrameGrabberEnabled;
   Edit19->Enabled = VideoGrabber1->FrameGrabberEnabled;

   // OnDrawOverFrames event
   CheckBox13->Enabled = VideoGrabber1->FrameGrabberEnabled;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1CaptureReadyToStart(TObject *Sender, bool &OkToStart)
//---------------------------------------------------------------------------
{
   if (MessageDlg ("Ready to start capture!", mtInformation, TMsgDlgButtons() << mbOK << mbCancel, 0) == mrOk ) {
      OkToStart = true;
   }
   else {
      OkToStart = false;
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1CaptureStarted(TObject *Sender)
//---------------------------------------------------------------------------
{
   Memo1->Lines->Add ("capturing " + IntToStr (VideoGrabber1->VideoWidth) + " " + IntToStr (VideoGrabber1->VideoHeight));
   Memo1->Lines->Add ("current frame rate: " + FormatFloat ("0.00", Extended (VideoGrabber1->CurrentFrameRate)) + " fps.");
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1DeviceLost(TObject *Sender)
//---------------------------------------------------------------------------
{
   Memo1->Lines->Add ("DEVICE LOST!");
   AssignListToComboBox (ComboBox2, VideoGrabber1->VideoDevices, VideoGrabber1->VideoDevice);
   AssignListToComboBox (ComboBox3, VideoGrabber1->AudioDevices, VideoGrabber1->AudioDevice);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1DiskFull(TObject *Sender)
//---------------------------------------------------------------------------
{
   Memo1->Lines->Add ("DISK FULL!");
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1RecompressStarted(TObject *Sender)
//---------------------------------------------------------------------------
{
   Memo1->Lines->Add ("recompressing...");
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1RecompressCompleted(TObject *Sender, bool Success)
//---------------------------------------------------------------------------
{
   if (Success) {
      Memo1->Lines->Add ("recompression successful.");
   }
   else {
      Memo1->Lines->Add ("recompression failed.");
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1PreviewStarted(TObject *Sender)
//---------------------------------------------------------------------------
{
   Memo1->Lines->Add ("previewing " + IntToStr (VideoGrabber1->VideoWidth) + " " + IntToStr (VideoGrabber1->VideoHeight));
   Memo1->Lines->Add ("current frame rate: " + FormatFloat ("0.00", Extended (VideoGrabber1->CurrentFrameRate)) + " fps.");
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1CopyPreallocDataStarted(TObject *Sender)
//---------------------------------------------------------------------------
{
   Memo1->Lines->Add ("copying data from preallocated file...");
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1CopyPreallocDataCompleted(TObject *Sender, bool Success)
//---------------------------------------------------------------------------
{
   if (Success) {
      Memo1->Lines->Add ("preallocated file copy successful.");
   }
   else {
      Memo1->Lines->Add ("preallocated file copy failed.");
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1CreatePreallocFileStarted(TObject *Sender)
//---------------------------------------------------------------------------
{
   Memo1->Lines->Add ("creating prealloc file...");
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1CreatePreallocFileCompleted(TObject *Sender, bool Success)
//---------------------------------------------------------------------------
{
   if (Success) {
      Memo1->Lines->Add ("preallocated file successfully created.");
   }
   else {
      Memo1->Lines->Add ("creation of preallocated file failed.");
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1CaptureCompleted(TObject *Sender,
      AnsiString FileName, bool Success)
//---------------------------------------------------------------------------
{
   if (Success) {
      Memo1->Lines->Add ("capture successful.");
   }
   else {
      Memo1->Lines->Add ("capture failed.");
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1FrameCaptureCompleted(TObject *Sender,
      const TFrameData &FrameData, TFrameCaptureDest DestType,
      AnsiString FileName, bool Success)
//---------------------------------------------------------------------------
{
   TForm *DestForm;
   TImage *DestImage;

   // ------ bmp || jpeg file
   if ((DestType == fc_BmpFile) || (DestType == fc_JpegFile)) {
      if (Success) {
          Memo1->Lines->Add (FileName + " successfully created.");
       }
       else {
          Memo1->Lines->Add ("Unable to write " + FileName);
       }
   }
   // ------ memory bitmap
   else if (DestType == fc_TBitmap) {
      if ((! VideoGrabber1->BurstMode) || (VideoGrabber1->BurstMode && (VideoGrabber1->BurstCount == 0)) ) { // reuse the same form
         if (SnapForm == NULL) {
            Application->CreateForm (__classid (TForm), &SnapForm);
            SnapForm->Position = poDefault;
            SnapForm->FormStyle = fsStayOnTop;
         }
         if (SnapImage != NULL) {
            SnapImage->Free();
         }
         SnapImage = new TImage (NULL);
         DestForm = SnapForm;
         DestImage = SnapImage;
      }
      else { // create a form for each image
         Application->CreateForm (__classid (TForm), &DestForm);
         DestForm->Position = poDefault;
         DestForm->FormStyle = fsStayOnTop;
         DestImage = new TImage (DestForm);
         DestImage->Parent = DestForm;
      }

      DestForm->ClientWidth = FrameData.Bitmap->Width;
      DestForm->ClientHeight = FrameData.Bitmap->Height;
      DestImage->AutoSize = true;
      DestImage->Picture->Bitmap->Assign (FrameData.Bitmap);
      DestImage->Parent = DestForm;
      if (! DestForm->Visible ) {
         DestForm->Show();
         Show();
      }
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1FrameProgress(TObject *Sender,
      const TFrameInfo &FrameInfo)
//---------------------------------------------------------------------------
{
   TVarRec SampleTimeVars[] = {FrameInfo.SampleTime_Hour, FrameInfo.SampleTime_Min, FrameInfo.SampleTime_Sec, FrameInfo.SampleTime_Hs};

   Edit4->Text = "frame: " + IntToStr (FrameInfo.FrameNumber)
               + " dropped:" + IntToStr (FrameInfo.DroppedFrameCount)
               + " time:" + Format ("%.2d:%.2d:%.2d %.2d", SampleTimeVars, (ARRAYSIZE(SampleTimeVars) - 1));

   if (FrameInfo.TimeCode_Sec == -1)  {
       Edit10->Text = "                     - - : - - : - -   - -";
   }
   else {
       TVarRec TimeCodeVars[] = {FrameInfo.TimeCode_Hour, FrameInfo.TimeCode_Min, FrameInfo.TimeCode_Sec, FrameInfo.TimeCode_Ff};
       Edit10->Text = Format ("                     %.2d:%.2d:%.2d %.2d", TimeCodeVars, (ARRAYSIZE(TimeCodeVars) - 1));
   }
   if (VideoGrabber1->CurrentState == cs_Player) {
      TrackBar1->Position = (int) VideoGrabber1->PlayerFramePosition;
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1DrawOverFrame(TObject *Sender,
      const TFrameInfo &FrameInfo, HDC Dc)
//---------------------------------------------------------------------------
{
   AnsiString TextString;

   if (CheckBox13->Checked)  {
      SetBkMode(Dc,OPAQUE);
      SetBkColor(Dc, clNavy);
      SetTextColor(Dc, clYellow);
      TextString = "Current frame: " + IntToStr (FrameInfo.FrameNumber);
      TextOut (Dc, 10, 40, TextString.c_str(), TextString.Length());
      TextString = "you can draw anything over frames";
      TextOut (Dc, 10, 60, TextString.c_str(), TextString.Length());
      TextString= "from the OnDrawOverFrame event";
      TextOut (Dc, 10, 80, TextString.c_str(), TextString.Length());
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1ResizeVideo(TObject *Sender, int SourceWidth, int SourceHeight)
//---------------------------------------------------------------------------
{
   VideoGrabber1->TextOnFrame_Right = SourceWidth;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1DeviceArrival(TObject *Sender)
//---------------------------------------------------------------------------
{
   Memo1->Lines->Add ("Device arrival.");
   AssignListToComboBox (ComboBox2, VideoGrabber1->VideoDevices, VideoGrabber1->VideoDevice);
   AssignListToComboBox (ComboBox3, VideoGrabber1->AudioDevices, VideoGrabber1->AudioDevice);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1DeviceRemoval(TObject *Sender)
//---------------------------------------------------------------------------
{
   Memo1->Lines->Add ("Device removal.");
   AssignListToComboBox (ComboBox2, VideoGrabber1->VideoDevices, VideoGrabber1->VideoDevice);
   AssignListToComboBox (ComboBox3, VideoGrabber1->AudioDevices, VideoGrabber1->AudioDevice);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1ErrorLog(TObject *Sender,
      int ErrorCode, AnsiString ErrorMsg)
//---------------------------------------------------------------------------
{
   Memo1->Lines->Add ("[" + IntToStr (ErrorCode) + "] " + ErrorMsg);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1PlayerStarted(TObject *Sender)
//---------------------------------------------------------------------------
{
   TrackBar1->Max = (int) VideoGrabber1->PlayerFrameCount;

   Memo1->Lines->Add ("Duration: " + FormatFloat ("0.00", Extended (VideoGrabber1->PlayerDuration) / 10000000));
   Memo1->Lines->Add ("Playback speed mult.: " + FormatFloat ("0.00", VideoGrabber1->PlayerFrameRate));
   Memo1->Lines->Add ("Frame Count: " + IntToStr (VideoGrabber1->PlayerFrameCount));

   Memo1->Lines->Add ("playing " + VideoGrabber1->PlayerFileName);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1PlayerEndOfStream(TObject *Sender)
//---------------------------------------------------------------------------
{
   Memo1->Lines->Add ("} of stream.");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1PlayerFileNotFound(TObject *Sender,
      AnsiString FileName)
//---------------------------------------------------------------------------
{
   Memo1->Lines->Add ("file ! found: " + FileName);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::SendVCRCommand(TObject *Sender)
//---------------------------------------------------------------------------
{
   if (VideoGrabber1->SendVCRCommand (TVCRCommand (((TMenuItem*) Sender)->Tag))) {
      Memo1->Lines->Add ("VCR command successful.");
   }
   else {
      Memo1->Lines->Add ("VCR command failed.");
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->StartCapture();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->StopCapture();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   // WARNING: USUALLY, THIS DIALOG ALLOWS TO CHANGE ONLY 1 PARAMETER AT THE SAME TIME

   VideoGrabber1->ShowDialog (dlg_StreamConfig);

   Edit1->Text = FloatToStr (VideoGrabber1->FrameRate);
   ComboBox1->ItemIndex = VideoGrabber1->VideoSize;
   ComboBox7->ItemIndex = VideoGrabber1->VideoSubtype;
   // now the frame rate, video size && video sub type match the current settings,
   // if any changed in the dialog
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->ShowDialog(dlg_Compressor);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->BurstType = fc_TBitmap;
   VideoGrabber1->BurstMode = true;
   // Enabling BurtMode starts the frame capture.
   // If BurstCount = 0 the frame capture won't stop.
   // the captured frames will be returned by the OnFrameCaptureCompleted event.
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->BurstType = fc_BmpFile;
   VideoGrabber1->BurstMode = true;
   // Enabling BurtMode starts the frame capture.
   // If BurstCount = 0 the frame capture won't stop.
   // The BMP file names will be generated automatically according to AutoFileName
   // && AutoFilePrefix. They will be returned by the OnFrameCaptureCompleted event.
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button7Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->BurstType = fc_JpegFile;
   VideoGrabber1->BurstMode = true;
   // Enabling BurtMode starts the frame capture.
   // If BurstCount = 0 the frame capture won't stop.
   // The JPEG file names will be generated automatically according to AutoFileName
   // && AutoFilePrefix. They will be returned by the OnFrameCaptureCompleted event.
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button8Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->StopPreview();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button9Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->StartPreview();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button10Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->ShowDialog(dlg_Device);

   ComboBox8->ItemIndex = int (VideoGrabber1->AnalogVideoStandard);
   // to make AnalogVideoStandard match the current setting, if modified in the dialog
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button12Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   Double Value;

   Value = StrToFloatDef (Edit1->Text, -1);
   if (Value != -1) {
      VideoGrabber1->FrameRate = Value;
   }
   else {
      ShowMessage ("invalid value");
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button13Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   if ((VideoGrabber1->CurrentState == cs_Preview) || (VideoGrabber1->CurrentState == cs_Capture)) {
      Form2->ShowModal();
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button15Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->ShowDialog (dlg_TVTuner);

   // the line below to refresh the listbox in case the analog video standard has been changed from the dialog
   AssignListToComboBox (ComboBox8, VideoGrabber1->AnalogVideoStandards, VideoGrabber1->AnalogVideoStandard);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button16Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->ClosePlayer();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button18Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   TrackBar2->Position = 100;
   TrackBar2Change (TrackBar2);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button19Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->BurstMode = false;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button21Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   if (CheckBox1->Checked) {
      VideoGrabber1->CaptureFrameTo (fc_BmpFile, Edit12->Text);
   }
   else {
      VideoGrabber1->CaptureFrameTo (fc_BmpFile, "");
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button22Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->FullScreenPreview = true;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button23Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->CaptureFrameTo (fc_TBitmap, "");
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button24Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   if (CheckBox1->Checked) {
      VideoGrabber1->CaptureFrameTo (fc_JpegFile, Edit12->Text);
   }
   else {
      VideoGrabber1->CaptureFrameTo (fc_JpegFile, "");
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::RadioGroup1Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->CompressionType = TCompressionType (RadioGroup1->ItemIndex);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::RadioGroup2Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->TextOnFrameAlign = TTextOnFrameAlign (RadioGroup2->ItemIndex);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::RadioGroup3Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->CompressionMode = TCompressionMode (RadioGroup3->ItemIndex);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::RadioGroup7Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->AutoFileName = TAutoFileName (RadioGroup7->ItemIndex);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Edit2Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->StoragePath = Edit2->Text;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Edit3Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->PreallocCapFileSizeInMB = StrToIntDef (Edit3->Text, 100);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Edit6Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->BurstCount = StrToIntDef (Edit6->Text, 1);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Edit9Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->BurstInterval = StrToIntDef (Edit9->Text, 1);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Edit7Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->TextOnFrame_Left = StrToIntDef (Edit7->Text, 0);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Edit14Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->TextOnFrame_Top = StrToIntDef (Edit14->Text, 0);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Edit15Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->TextOnFrame_Right = StrToIntDef (Edit15->Text, 0);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Edit16Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   Shape1->Width = StrToIntDef (Edit16->Text, 0);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Edit17Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   Shape1->Height = StrToIntDef (Edit17->Text, 0);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Edit18Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   Shape1->Top = StrToIntDef (Edit18->Text, 0);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Edit19Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   Shape1->Left = StrToIntDef (Edit19->Text, 0);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   Edit12->Enabled = CheckBox1->Checked;
   // look at "Button21Click" "&& Button24Click" to use the file name
}

//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox2Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->Visible = CheckBox2->Checked;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox3Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->CaptureAudio = CheckBox3->Checked;
   EnableDeviceDependentOptions();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox4Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   // in this sample the transparent window is created in the OnColorKeyChange event below when the color key is set
   VideoGrabber1->ColorKeyEnabled = CheckBox4->Checked;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1ColorKeyChange(TObject *Sender,
      TColor ColorKey)
//---------------------------------------------------------------------------
{
   TPanel *Panel;

   if (TransparentForm)  {
      TransparentForm = new TForm (this);
      TransparentForm->Width = 300;
      TransparentForm->Height = 100;
      TransparentForm->Position = poScreenCenter;
      TransparentForm->FormStyle = fsStayOnTop;
   };
   Panel = new TPanel (TransparentForm);
   Panel->Parent = TransparentForm;
   Panel->BevelInner = bvNone;
   Panel->BevelOuter = bvNone;
   Panel->Align = alClient;
   Panel->Caption = "transparent window";
   Panel->Font->Color = clRed;
   Panel->Font->Size = 16;

   TransparentForm->Color = ColorKey;
   Panel->Color = ColorKey;

   TransparentForm->Show();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox5Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->RenderAudio = CheckBox5->Checked;
   EnableDeviceDependentOptions();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox6Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->TextOnFrameString = Memo2->Text;
   VideoGrabber1->TextOnFrameEnabled = CheckBox6->Checked;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox7Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->PreallocCapFileEnabled = CheckBox7->Checked;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox8Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->OpenDMLFormat = CheckBox8->Checked;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox9Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->OverlayEnabled = CheckBox9->Checked;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox10Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->TextOnFrameTransparent = CheckBox10->Checked;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox11Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   Edit19Change (this);
   Edit18Change (this);
   Edit16Change (this);
   Edit17Change (this);
   VideoGrabber1->ShapeOnFrameEnabled = CheckBox11->Checked;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox12Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->DVReduceFrameRate = CheckBox12->Checked;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox13Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   // See the OnDrawOverFrames event
}

//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox14Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->DVUseExternalAudio = ! CheckBox14->Checked;
   EnableDeviceDependentOptions();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox15Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->DVNativeInterleavedToAVI = CheckBox15->Checked;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox17Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->FrameGrabberEnabled = CheckBox17->Checked;
   EnableDeviceDependentOptions();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->VideoSize = ComboBox1->ItemIndex;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox2Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->VideoDevice = ComboBox2->ItemIndex;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox3Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->AudioDevice = ComboBox3->ItemIndex;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox4Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->AudioFormat = TAudioFormat (ComboBox4->ItemIndex);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox5Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->AudioCompressor = ComboBox5->ItemIndex;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox6Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->VideoCompressor = ComboBox6->ItemIndex;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox7Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->VideoSubtype = ComboBox7->ItemIndex;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox8Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->AnalogVideoStandard = ComboBox8->ItemIndex;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox9Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->VideoCrossbarInput = ComboBox9->ItemIndex;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox10Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->AudioInput = ComboBox10->ItemIndex;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::UpDown1Click(TObject *Sender, TUDBtnType Button)
//---------------------------------------------------------------------------
{
   VideoGrabber1->PlayerFrameRate = Extended (UpDown1->Position) / 1000;
   Edit8->Text = FormatFloat("0.0", VideoGrabber1->PlayerFrameRate);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::UpDown2Click(TObject *Sender, TUDBtnType Button)
//---------------------------------------------------------------------------
{
   VideoGrabber1->PlayerFastSeekMultiplier = UpDown2->Position;
   Edit21->Text = IntToStr (VideoGrabber1->PlayerFastSeekMultiplier);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   OpenDialog1->FileName = "*.mpg;*.mpeg;*.avi;*.wav;*.mp3;*.asf;*.wmv";
   if (OpenDialog1->Execute()) {
      VideoGrabber1->PlayerFileName = OpenDialog1->FileName;
      VideoGrabber1->OpenPlayer();
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->PausePlayer();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton3Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->StopPlayer();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton4Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->RunPlayer();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton5Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->RewindsPlayer();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton6Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->FastForwardsPlayer();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton7Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   if (VideoGrabber1->Last_AVICapture_FileName != "") {
      VideoGrabber1->PlayerFileName = VideoGrabber1->Last_AVICapture_FileName;
      VideoGrabber1->OpenPlayer();
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton8Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->RunPlayerBackwards();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar1Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   if (!  VideoGrabber1->InFrameProgressEvent) { // to avoid loopback troubles if TrackBar1.Position is set from the FrameProgess event
      VideoGrabber1->PlayerFramePosition = TrackBar1->Position;
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar2Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->PreviewZoomSize = (unsigned short) TrackBar2->Position;
   Edit11->Text = IntToStr (VideoGrabber1->PreviewZoomSize) + "%";
}

//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar3Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->AudioVolume = TrackBar3->Position;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar4Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->AudioInputLevel = TrackBar4->Position;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::AutoPlayClip1Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   AutoPlayClip1->Checked = ! AutoPlayClip1->Checked;
   VideoGrabber1->PlayerAutoStart = AutoPlayClip1->Checked;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::RefreshPreviewOnParamChange1Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   RefreshPreviewOnParamChange1->Checked = ! RefreshPreviewOnParamChange1->Checked;
   VideoGrabber1->RefreshPreviewOnParamChange = RefreshPreviewOnParamChange1->Checked;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Memo2Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->TextOnFrameString = Memo2->Text;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
   Close();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Detachwindow1Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->DetachVideoWindow (20, 20, 320, 240);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Attachwindow1Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->AttachVideoWindow();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::DSCALERAddtolist1Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   // this demonstrates the use of the DSCALER deinterlacer. The filter can be downloaded from the following URL:

   // you have to know the CLSID of the third-party filter you want to use,
   // look at the user guide, chapter about "Third-party filters" to know how to retrieve it.

static const GUID CLSID_DSCALER = {0x463D645D, 0x48F7, 0x11D4, { 0x84,0x64,0x00,0x08,0xC7,0x82,0xA2,0x57} };

   ThirdPartyFilterIndex = VideoGrabber1->ThirdPartyFilter_AddToList (tpf_VideoSource, CLSID_DSCALER, "DSCALER deinterlacer", true, true);
   if (ThirdPartyFilterIndex != -1)  {
      DSCALERAddtolist1->Enabled = false;
      DSCALERShowDialog1->Enabled = true;
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::DSCALERShowDialog1Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->ThirdPartyFilter_ShowDialog (tpf_VideoSource, ThirdPartyFilterIndex);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::DSCALERClearList1Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->ThirdPartyFilter_ClearList (tpf_VideoSource);
   DSCALERAddtolist1->Enabled = true;
   DSCALERShowDialog1->Enabled = false;
}


