unit MainDemoQualDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, VidGrab;

type
  TForm2 = class(TForm)
    TrackBar2: TTrackBar;
    TrackBar1: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    TrackBar7: TTrackBar;
    TrackBar8: TTrackBar;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OnTrackBarClick (Sender: TObject);
  private
     CanUpdate: Boolean;
     procedure InitTrackBar (TrackBar: TTrackBar; Setting: TVideoQuality; ResetToDefault, Reversed: Boolean);
  public
     procedure InitTrackBars (ResetToDefault: Boolean);
  end;

var
  Form2: TForm2;

implementation

uses MainDemo_;

{$R *.DFM}

//------------------------------------------------------------------------------
procedure TForm2.InitTrackBar (TrackBar: TTrackBar; Setting: TVideoQuality; ResetToDefault: Boolean; Reversed: Boolean);
//------------------------------------------------------------------------------
begin
   if Reversed then begin
      TrackBar.Tag := - integer (Setting) - 1;
   end
   else begin
      TrackBar.Tag := integer (Setting) + 1;
   end;
   if not Form1.VideoGrabber1.IsVideoQualitySettingAvailable (Setting) then begin
      TrackBar.Enabled := False;
      TrackBar.Frequency := 0;
      TrackBar.Min := 0;
      TrackBar.Max := 1;
      if not Reversed then begin
         TrackBar.Position := 0;
      end
      else begin
         TrackBar.Position := 1;
      end;
   end
   else begin
      if not ResetToDefault then begin
         CanUpdate := false;
      end;
      TrackBar.Enabled := True;
      TrackBar.Min := Form1.VideoGrabber1.VideoQualityMin (Setting);
      TrackBar.Max := Form1.VideoGrabber1.VideoQualityMax (Setting);
      TrackBar.Frequency := Form1.VideoGrabber1.VideoQualityStep (Setting);
      if ResetToDefault then begin
         if not Reversed then begin
            TrackBar.Position := Form1.VideoGrabber1.VideoQualityDefault (Setting);
         end
         else begin
            TrackBar.Position := TrackBar.Max - Form1.VideoGrabber1.VideoQualityDefault (Setting) + TrackBar.Min;
         end;
      end
      else begin
         if not Reversed then begin
            TrackBar.Position := Form1.VideoGrabber1.GetVideoQuality (Setting);
         end
         else begin
            TrackBar.Position := TrackBar.Max - Form1.VideoGrabber1.GetVideoQuality (Setting) + TrackBar.Min;
         end;
      end;
   end;
   CanUpdate := True;
end;

//------------------------------------------------------------------------------
procedure TForm2.InitTrackBars (ResetToDefault: Boolean);
//------------------------------------------------------------------------------
begin
   InitTrackBar (TrackBar1, vq_Brightness, ResetToDefault, True);
   InitTrackBar (TrackBar2, vq_Contrast, ResetToDefault, True);
   InitTrackBar (TrackBar3, vq_Hue, ResetToDefault, True);
   InitTrackBar (TrackBar4, vq_Saturation, ResetToDefault, True);
   InitTrackBar (TrackBar5, vq_Sharpness, ResetToDefault, True);
   InitTrackBar (TrackBar6, vq_Gamma, ResetToDefault, True);
   InitTrackBar (TrackBar7, vq_WhiteBalance, ResetToDefault, True);
   InitTrackBar (TrackBar8, vq_Gain, ResetToDefault, True);
end;

//------------------------------------------------------------------------------
procedure TForm2.OnTrackBarClick (Sender: TObject);
//------------------------------------------------------------------------------
var
   Selector: integer;
   Reversed: Boolean;
begin
   if not CanUpdate then Exit;
   Selector := TTrackbar(Sender).Tag;
   if Selector < 0 then begin
      Selector := - Selector;
      Reversed := True;
   end
   else begin
      Reversed := False;
   end;
   Dec (Selector);
   if not Reversed then begin
      Form1.VideoGrabber1.SetVideoQuality (TVideoQuality (Selector), TTrackbar (Sender).Position);
   end
   else begin
      Form1.VideoGrabber1.SetVideoQuality (TVideoQuality (Selector), TTrackbar (Sender).Max - TTrackbar (Sender).Position + TTrackbar (Sender).Min);
   end;
end;

//------------------------------------------------------------------------------
procedure TForm2.Button1Click(Sender: TObject);
//------------------------------------------------------------------------------
begin
   InitTrackBars (True);
end;

//------------------------------------------------------------------------------
procedure TForm2.Button2Click(Sender: TObject);
//------------------------------------------------------------------------------
begin
   Close;
end;

//------------------------------------------------------------------------------
procedure TForm2.FormShow(Sender: TObject);
//------------------------------------------------------------------------------
begin
   Form2.InitTrackBars (False);
end;

end.
