//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "NonVisible_.h"
#include "VidGrab.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VidGrab"
#pragma resource "*.dfm"

TForm1 *Form1;
TVideoGrabber *VGrab;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
//---------------------------------------------------------------------------
{
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   if (VGrab == NULL) {
      // 1. create the component
      VGrab = new TVideoGrabber (this);

      // 2. set its Parent property
      VGrab->Parent = this;

      // 3. set the properties and events
      VGrab->VideoDevice = 0;
      VGrab->Visible = False;
      VGrab->AutoStartPreview = True;

      VGrab->OnChangeVideoDevice = OnChangeVideoDevice;
      VGrab->OnFrameCaptureCompleted = OnFrameCaptureCompleted;

      ComboBox1->Items->Text = VGrab->VideoDevices;
      ComboBox1->ItemIndex = 0;

      Button1->Enabled = False;
      Button2->Enabled = True;
      Button3->Enabled = True;
      ComboBox1->Enabled = True;
      ComboBox2->Enabled = True;
      ComboBox3->Enabled = True;

      // 4. call DynamicallyCreated() to enable the component
      VGrab->DynamicallyCreated();
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   if (VGrab != NULL) {
      VGrab->CaptureFrameTo (fc_TBitmap, "");
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   if (VGrab != NULL) {
      VGrab->Free();
      VGrab = NULL;
      Image1->Picture->Assign (NULL);

      Button1->Enabled = True;
      Button2->Enabled = False;
      Button3->Enabled = False;
      ComboBox1->Enabled = False;
      ComboBox2->Enabled = False;
      ComboBox3->Enabled = False;
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   if (VGrab != NULL) {
      VGrab->VideoDevice =ComboBox1->ItemIndex;
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox2Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   if (VGrab != NULL) {
      VGrab->VideoSize =ComboBox2->ItemIndex;
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox3Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   if (VGrab != NULL) {
      VGrab->VideoCrossbarInput =ComboBox3->ItemIndex;
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::OnChangeVideoDevice(TObject *Sender)
//---------------------------------------------------------------------------
{
   Image1->Picture->Assign (NULL);

   ComboBox2->Clear();
   ComboBox2->Items->Text = ((TVideoGrabber*) Sender)->VideoSizes;
   ComboBox2->ItemIndex = ((TVideoGrabber*) Sender)->VideoSize;

   ComboBox3->Clear();
   ComboBox3->Items->Text = ((TVideoGrabber*) Sender)->VideoCrossbarInputs;
   ComboBox3->ItemIndex = ((TVideoGrabber*) Sender)->VideoCrossbarInput;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::OnFrameCaptureCompleted(TObject *Sender,
      const TFrameData &FrameData, TFrameCaptureDest DestType,
      AnsiString FileName, bool Success)
//---------------------------------------------------------------------------
{
   Image1->AutoSize = true;
   Image1->Picture->Bitmap->Handle = FrameData.Bitmap->Handle;
   FrameData.Bitmap->ReleaseHandle();
}


