unit NonVisible_;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, VidGrab, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Image1: TImage;
    Button3: TButton;
    ComboBox3: TComboBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
  private
    VGrab: TVideoGrabber;
  public
    procedure ChangeVideoDevice (Sender: TObject);
    procedure OnFrameCaptureCompleted(Sender: TObject; const FrameData: TFrameData;
              DestType: TFrameCaptureDest; FileName: String; Success: Boolean);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//------------------------------------------------------------------------------
procedure TForm1.Button1Click(Sender: TObject);
//------------------------------------------------------------------------------
begin
   if not assigned (VGrab) then begin

      // 1. create the component
      VGrab := TVideoGrabber.Create (Self);

      // 2. set its Parent property
      VGrab.Parent := Self;

      // 3. set the properties and events
      VGrab.VideoDevice := 0;
      VGrab.Visible := False;
      VGrab.AutoStartPreview := True;

      VGrab.OnChangeVideoDevice := ChangeVideoDevice;
      VGrab.OnFrameCaptureCompleted := OnFrameCaptureCompleted;

      ComboBox1.Items.Text := VGrab.VideoDevices;
      ComboBox1.ItemIndex := 0;

      Button1.Enabled := False;
      Button2.Enabled := True;
      Button3.Enabled := True;
      ComboBox1.Enabled := True;
      ComboBox2.Enabled := True;
      ComboBox3.Enabled := True;

      // 4. call DynamicallyCreated() to enable the component
      VGrab.DynamicallyCreated;
   end;
end;

//------------------------------------------------------------------------------
procedure TForm1.Button2Click(Sender: TObject);
//------------------------------------------------------------------------------
begin
   if assigned (VGrab) then begin
      VGrab.CaptureFrameTo (fc_TBitmap);
   end;
end;

//------------------------------------------------------------------------------
procedure TForm1.Button3Click(Sender: TObject);
//------------------------------------------------------------------------------
begin
   if assigned (VGrab) then begin
      VGrab.Free;
      VGrab := nil;
      Image1.Picture.Assign (nil);

      Button1.Enabled := True;
      Button2.Enabled := False;
      Button3.Enabled := False;
      ComboBox1.Enabled := False;
      ComboBox2.Enabled := False;
      ComboBox3.Enabled := False;
   end;
end;

//------------------------------------------------------------------------------
procedure TForm1.ComboBox1Change(Sender: TObject);
//------------------------------------------------------------------------------
begin
   if assigned (VGrab) then begin
      VGrab.VideoDevice :=ComboBox1.ItemIndex;
   end;
end;

//------------------------------------------------------------------------------
procedure TForm1.ComboBox2Change(Sender: TObject);
//------------------------------------------------------------------------------
begin
   if assigned (VGrab) then begin
      VGrab.VideoSize :=ComboBox2.ItemIndex;
   end;
end;

//------------------------------------------------------------------------------
procedure TForm1.ComboBox3Change(Sender: TObject);
//------------------------------------------------------------------------------
begin
   if assigned (VGrab) then begin
      VGrab.VideoCrossbarInput :=ComboBox3.ItemIndex;
   end;
end;

//------------------------------------------------------------------------------
procedure TForm1.ChangeVideoDevice (Sender: TObject);
//------------------------------------------------------------------------------
begin
   with TVideoGrabber(Sender) do begin
      Image1.Picture.Assign (nil);

      ComboBox2.Clear;
      ComboBox2.Items.Text := VideoSizes;
      ComboBox2.ItemIndex := VideoSize;

      ComboBox3.Clear;
      ComboBox3.Items.Text := VideoCrossbarInputs;
      ComboBox3.ItemIndex := VideoCrossbarInput;
   end;
end;

//------------------------------------------------------------------------------
procedure TForm1.OnFrameCaptureCompleted(Sender: TObject; const FrameData: TFrameData;
              DestType: TFrameCaptureDest; FileName: String; Success: Boolean);
//------------------------------------------------------------------------------
begin
   Image1.AutoSize := true;
   Image1.Picture.Bitmap.Handle := FrameData.Bitmap.Handle;
   FrameData.Bitmap.ReleaseHandle;
end;

end.
