//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "QuickStartDemo_.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VidGrab"
#pragma link "VidGrab"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
//---------------------------------------------------------------------------
{
   FFrameCount= 0;

   ComboBox1->Items->Text = VideoGrabber1->VideoDevices;
   ComboBox1->ItemIndex = VideoGrabber1->VideoDevice;

   ComboBox3->Items->Text = VideoGrabber1->AudioDevices;
   ComboBox3->ItemIndex = VideoGrabber1->AudioDevice;
   ComboBox3->Enabled = VideoGrabber1->CaptureAudio;

   CheckBox1->Checked = VideoGrabber1->CaptureAudio;
   CheckBox2->Checked = VideoGrabber1->RenderAudio;

   StatusBar1->Panels->Items[0]->Text = "storage path: " + VideoGrabber1->StoragePath;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1FrameCaptureCompleted(TObject *Sender,
      const TFrameData &FrameData, TFrameCaptureDest DestType,
      AnsiString FileName, bool Success)
//---------------------------------------------------------------------------
{
   switch (DestType) {
      case fc_BmpFile:
         StatusBar1->Panels->Items[1]->Text = "File " + FileName + " created";
      break;

      case fc_JpegFile:
         StatusBar1->Panels->Items[1]->Text = "File " + FileName + " created";
      break;

      case fc_TBitmap:
         Image1->Picture->Bitmap->Handle = FrameData.Bitmap->Handle;
         FrameData.Bitmap->ReleaseHandle();
         FFrameCount ++;
         Edit1->Text = "  " + IntToStr (FFrameCount);
      break;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->BurstCount = 0;
   VideoGrabber1->BurstMode = True;
   VideoGrabber1->CaptureFrameTo (fc_TBitmap, "");
   // the captured frames are returned by the OnFrameCaptureCompleted event.
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->BurstMode = False;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->StartPreview();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->StartCapture();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->StopCapture();
   StatusBar1->Panels->Items[1]->Text = "last AVI capture: " + VideoGrabber1->Last_AVICapture_FileName;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->CaptureFrameTo (fc_JpegFile, "");
   // the captured file is returned by the OnFrameCaptureCompleted event.
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button7Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->CaptureFrameTo (fc_BmpFile, "");
   // the captured file is returned by the OnFrameCaptureCompleted event.
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button8Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->StopPreview();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->VideoDevice = ComboBox1->ItemIndex;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox2Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->AnalogVideoStandard = ComboBox2->ItemIndex;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox3Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->AudioDevice = ComboBox3->ItemIndex;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox4Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->VideoCrossbarInput = ComboBox4->ItemIndex;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox5Change(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->VideoSize = ComboBox5->ItemIndex;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->CaptureAudio = CheckBox1->Checked;
   ComboBox3->Enabled = VideoGrabber1->CaptureAudio;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox2Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   VideoGrabber1->RenderAudio = CheckBox2->Checked;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
//---------------------------------------------------------------------------
{
   Close();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1ChangeVideoDevice(TObject *Sender)
//---------------------------------------------------------------------------
{
   ComboBox1->Items->Text = VideoGrabber1->VideoDevices;
   ComboBox1->ItemIndex = VideoGrabber1->VideoDevice;

   ComboBox2->Items->Text = VideoGrabber1->AnalogVideoStandards;
   ComboBox2->ItemIndex = VideoGrabber1->AnalogVideoStandard;
   ComboBox2->Enabled = VideoGrabber1->IsAnalogVideoDecoderAvailable;

   ComboBox4->Items->Text = VideoGrabber1->VideoCrossbarInputs;
   ComboBox4->ItemIndex = VideoGrabber1->VideoCrossbarInput;
   ComboBox4->Enabled = VideoGrabber1->IsVideoCrossbarAvailable;

   ComboBox5->Items->Text = VideoGrabber1->VideoSizes;
   ComboBox5->ItemIndex = VideoGrabber1->VideoSize;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1CaptureStarted(TObject *Sender)
//---------------------------------------------------------------------------
{
   StatusBar1->Panels->Items[1]->Text = "capturing...";
}

//---------------------------------------------------------------------------
void __fastcall TForm1::VideoGrabber1CaptureCompleted(TObject *Sender,
      AnsiString FileName, bool Success)
//---------------------------------------------------------------------------
{
   StatusBar1->Panels->Items[1]->Text = "File " + FileName + " created";
}



