unit QuickStartDemo_;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, VidGrab, ComCtrls, Menus;

type
  TForm1 = class(TForm)
    Image1: TImage;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    GroupBox1: TGroupBox;
    Button4: TButton;
    Button5: TButton;
    GroupBox2: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    StatusBar1: TStatusBar;
    Button6: TButton;
    Button7: TButton;
    GroupBox3: TGroupBox;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    GroupBox4: TGroupBox;
    ComboBox3: TComboBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    ComboBox4: TComboBox;
    VideoGrabber1: TVideoGrabber;
    ComboBox5: TComboBox;
    GroupBox5: TGroupBox;
    Button3: TButton;
    Button8: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure VideoGrabber1ChangeVideoDevice(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure VideoGrabber1CaptureCompleted(Sender: TObject;
      FileName: String; Success: Boolean);
    procedure VideoGrabber1CaptureStarted(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure VideoGrabber1FrameCaptureCompleted(Sender: TObject;
      const FrameData: TFrameData; DestType: TFrameCaptureDest;
      FileName: String; Success: Boolean);
    procedure ComboBox5Change(Sender: TObject);
  private
     FFrameCount: integer;
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//------------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
//------------------------------------------------------------------------------
begin
   FFrameCount:= 0;

   ComboBox1.Items.Text := VideoGrabber1.VideoDevices;
   ComboBox1.ItemIndex := VideoGrabber1.VideoDevice;

   ComboBox3.Items.Text := VideoGrabber1.AudioDevices;
   ComboBox3.ItemIndex := VideoGrabber1.AudioDevice;
   ComboBox3.Enabled := VideoGrabber1.CaptureAudio;

   CheckBox1.Checked := VideoGrabber1.CaptureAudio;
   CheckBox2.Checked := VideoGrabber1.RenderAudio;

   StatusBar1.Panels[0].Text:= 'storage path: ' + VideoGrabber1.StoragePath;
end;

//------------------------------------------------------------------------------
procedure TForm1.Button1Click(Sender: TObject);
//------------------------------------------------------------------------------
begin
   VideoGrabber1.BurstCount := 0;
   VideoGrabber1.BurstMode := True;
   VideoGrabber1.CaptureFrameTo (fc_TBitmap, '');
   // the captured frames are returned by the OnFrameCaptureCompleted event.
end;

//------------------------------------------------------------------------------
procedure TForm1.Button2Click(Sender: TObject);
//------------------------------------------------------------------------------
begin
   VideoGrabber1.BurstMode := False;
end;

//------------------------------------------------------------------------------
procedure TForm1.Button3Click(Sender: TObject);
//------------------------------------------------------------------------------
begin
   VideoGrabber1.StartPreview;
end;

//------------------------------------------------------------------------------
procedure TForm1.Button4Click(Sender: TObject);
//------------------------------------------------------------------------------
begin
   VideoGrabber1.StartCapture;
end;

//------------------------------------------------------------------------------
procedure TForm1.Button5Click(Sender: TObject);
//------------------------------------------------------------------------------
begin
   VideoGrabber1.StopCapture;
   StatusBar1.Panels[1].Text := 'Last AVI capture: ' + VideoGrabber1.Last_AVICapture_FileName;
end;

//------------------------------------------------------------------------------
procedure TForm1.Button6Click(Sender: TObject);
//------------------------------------------------------------------------------
begin
   VideoGrabber1.CaptureFrameTo (fc_JpegFile, '');
   // the captured file is returned by the OnFrameCaptureCompleted event.
end;

//------------------------------------------------------------------------------
procedure TForm1.Button7Click(Sender: TObject);
//------------------------------------------------------------------------------
begin
   VideoGrabber1.CaptureFrameTo (fc_BmpFile, '');
   // the captured file is returned by the OnFrameCaptureCompleted event.
end;

//------------------------------------------------------------------------------
procedure TForm1.Button8Click(Sender: TObject);
//------------------------------------------------------------------------------
begin
   VideoGrabber1.StopPreview;
end;

//------------------------------------------------------------------------------
procedure TForm1.ComboBox1Change(Sender: TObject);
//------------------------------------------------------------------------------
begin
   VideoGrabber1.VideoDevice := ComboBox1.ItemIndex;
end;

//------------------------------------------------------------------------------
procedure TForm1.ComboBox2Change(Sender: TObject);
//------------------------------------------------------------------------------
begin
   VideoGrabber1.AnalogVideoStandard := ComboBox2.ItemIndex;
end;

//------------------------------------------------------------------------------
procedure TForm1.ComboBox3Change(Sender: TObject);
//------------------------------------------------------------------------------
begin
   VideoGrabber1.AudioDevice := ComboBox3.ItemIndex;
end;

//------------------------------------------------------------------------------
procedure TForm1.ComboBox4Change(Sender: TObject);
//------------------------------------------------------------------------------
begin
   VideoGrabber1.VideoCrossbarInput := ComboBox4.ItemIndex;
end;

//------------------------------------------------------------------------------
procedure TForm1.ComboBox5Change(Sender: TObject);
//------------------------------------------------------------------------------
begin
   VideoGrabber1.VideoSize := ComboBox5.ItemIndex;
end;

//------------------------------------------------------------------------------
procedure TForm1.CheckBox1Click(Sender: TObject);
//------------------------------------------------------------------------------
begin
   VideoGrabber1.CaptureAudio := CheckBox1.Checked;
   ComboBox3.Enabled := VideoGrabber1.CaptureAudio;
end;

//------------------------------------------------------------------------------
procedure TForm1.CheckBox2Click(Sender: TObject);
//------------------------------------------------------------------------------
begin
   VideoGrabber1.RenderAudio := CheckBox2.Checked;
end;

//------------------------------------------------------------------------------
procedure TForm1.Exit1Click(Sender: TObject);
//------------------------------------------------------------------------------
begin
   Close;
end;

//------------------------------------------------------------------------------
procedure TForm1.VideoGrabber1FrameCaptureCompleted(Sender: TObject;
  const FrameData: TFrameData; DestType: TFrameCaptureDest;
  FileName: String; Success: Boolean);
//------------------------------------------------------------------------------
begin
   case DestType of
      fc_BmpFile, fc_JPEGFile: begin
         StatusBar1.Panels[1].Text := 'File ' + FileName + ' created';
      end;
      fc_TBitmap: begin
         Image1.Picture.Bitmap.Handle := FrameData.Bitmap.Handle;
         FrameData.Bitmap.ReleaseHandle;

         inc (FFrameCount);
         Edit1.Text := '  ' + inttostr (FFrameCount);
      end;
   end;
end;

//------------------------------------------------------------------------------
procedure TForm1.VideoGrabber1ChangeVideoDevice(Sender: TObject);
//------------------------------------------------------------------------------
begin
   ComboBox1.Items.Text := VideoGrabber1.VideoDevices;
   ComboBox1.ItemIndex := VideoGrabber1.VideoDevice;

   ComboBox2.Items.Text := VideoGrabber1.AnalogVideoStandards;
   ComboBox2.ItemIndex := integer (VideoGrabber1.AnalogVideoStandard);
   ComboBox2.Enabled := VideoGrabber1.IsAnalogVideoDecoderAvailable;

   ComboBox4.Items.Text := VideoGrabber1.VideoCrossbarInputs;
   ComboBox4.ItemIndex := integer (VideoGrabber1.VideoCrossbarInput);
   ComboBox4.Enabled := VideoGrabber1.IsVideoCrossbarAvailable;

   ComboBox5.Items.Text := VideoGrabber1.VideoSizes;
   ComboBox5.ItemIndex := integer (VideoGrabber1.VideoSize);
end;

procedure TForm1.VideoGrabber1CaptureStarted(Sender: TObject);
begin
   StatusBar1.Panels[1].Text := 'capturing...';
end;

//------------------------------------------------------------------------------
procedure TForm1.VideoGrabber1CaptureCompleted(Sender: TObject;
  FileName: String; Success: Boolean);
//------------------------------------------------------------------------------
begin
   StatusBar1.Panels[1].Text := 'File ' + FileName + ' created';
end;

end.
